var Crystal = window.Crystal || {};

/** @param {jQuery} $ jQuery Object */
!function($, window, document, _undefined)
{
    "use strict";

    Crystal.CopyCC = XF.Element.newHandler({
        options: {
            copyText: ''
        },

        copyText: null,

        init: function()
        {
            let parent = this.$target.closest(".bbCodeBlock").find("code");
            if (navigator.clipboard)
            {
                this.$target.removeClass('is-hidden');
            }
            if(parent.length)
            {
                this.copyText = parent.text();
            }

            if (!this.copyText)
            {
                console.error('No text to copy to clipboard');
                return;
            }

            this.$target.on('click', XF.proxy(this, 'click'));
        },

        click: function()
        {
            var t = this;

            navigator.clipboard.writeText(this.copyText)
                .then(function()
                {
                    if (XF.config.PopupAppearance === 'appearanceup')
                    {
                        $('.Message-copy-button-cc').css("display","block");
                        $(".Message-copy-button-cc").animate({bottom: '20px'});
                        //hide
                        window.setTimeout(t.animationNotification, 3000);
                        window.setTimeout(t.hideNotification, 3400);
                    }

                    else if (XF.config.PopupAppearance === 'molten') {
                        $('.Message-copy-button-cc').css("display","block");
                        $(".Message-copy-button-cc").animate({opacity: '0.8'});
                        //hide
                        window.setTimeout(t.animationNotification, 3000);
                        window.setTimeout(t.hideNotification, 3400);
                    }

                    else if (XF.config.PopupAppearance === 'bounce') {
                        $('.Message-copy-button-cc').css("display","block");
                        $(".Message-copy-button-cc").animate({bottom: '20px'});
                        //bounce
                        if ($('.Message-copy-button-cc').css("bottom","20px")){
                            $(".Message-copy-button-cc").animate({bottom: '10px'});
                        }
                        if ($('.Message-copy-button-cc').css("bottom","10px")){
                            $(".Message-copy-button-cc").animate({bottom: '20px'});
                        }
                        //hide
                        window.setTimeout(t.animationNotification, 3000);
                        window.setTimeout(t.hideNotification, 3400);
                    }
                });
        },
        animationNotification : function () {
            if (XF.config.PopupAppearance === 'appearanceup' || XF.config.PopupAppearance === 'bounce'){
                $(".Message-copy-button-cc").animate({bottom: '-16px'});
            }
            else if (XF.config.PopupAppearance === 'molten'){
                $(".Message-copy-button-cc").animate({opacity: '0'})
            }
        },
        hideNotification : function () {
            $('.Message-copy-button-cc').css("display","none");
        }
    });

    XF.Element.register('copy-cc', 'Crystal.CopyCC');
}
(jQuery, window, document);